var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

export var branch = function branch(predicate) {
  return function (left) {
    return function (right) {
      return function () {
        return predicate.apply(undefined, arguments) ? right.apply(undefined, arguments) : left.apply(undefined, arguments);
      };
    };
  };
};

export var compose = function compose() {
  for (var _len = arguments.length, fs = Array(_len), _key = 0; _key < _len; _key++) {
    fs[_key] = arguments[_key];
  }

  var gs = fs.reverse();

  return function (x) {
    return gs.reduce(function (y, f) {
      return f(y);
    }, x);
  };
};

export var deepMerge = function deepMerge() {
  for (var _len2 = arguments.length, srcs = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    srcs[_key2] = arguments[_key2];
  }

  return compose(reduce(function (targ, src) {
    return reduce(function (t, _ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          k = _ref2[0],
          v = _ref2[1];

      t[k] = isObject(t[k]) && isObject(v) ? deepMerge(t[k], v) : v;

      return t;
    })(targ)(src);
  })({}), map(entries))(srcs);
};

export var entries = function entries(src) {
  return Object.keys(src).map(function (key) {
    return [key, src[key]];
  });
};

export var getPath = function getPath(_ref3, src) {
  var _ref4 = _toArray(_ref3),
      key = _ref4[0],
      path = _ref4.slice(1);

  return path.length < 1 ? src[key] : getPath(path, src[key]);
};

export var isObject = function isObject(x) {
  return typeOf(x) === "object";
};

export var map = function map(f) {
  return function (xs) {
    return xs.map(f);
  };
};

export var reduce = function reduce(f) {
  return function (init) {
    return function (xs) {
      return xs.reduce(f, init);
    };
  };
};

export var set = function set(key, value, target) {
  return Object.assign({}, target, _defineProperty({}, key, value));
};

export var setPath = function setPath(_ref5, value, target) {
  var _ref6 = _toArray(_ref5),
      key = _ref6[0],
      path = _ref6.slice(1);

  return path.length < 1 ? set(key, value, target) : _extends({}, target, _defineProperty({}, key, setPath(path, value, target.hasOwnProperty(key) ? target[key] : {})));
};

export var split = function split(delimiter) {
  return function (s) {
    return s.split(delimiter);
  };
};

export var typeOf = function typeOf(x) {
  return {}.toString.call(x).match(/\s([a-z|A-Z]+)/)[1].toLowerCase();
};